﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace _10964_ImageAutoSize
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            textControl1.ResetText();

            // 插入文本框TextFrame
            TXTextControl.TextFrame frame = new TXTextControl.TextFrame(new System.Drawing.Size(8000, 4000));
            frame.ID = 1000;
            textControl1.TextFrames.Add(frame, textControl1.InputPosition.TextPosition);
        }

        private void 插入图片ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            InsertImage();
        }

    private void InsertImage()
    {
        // 完成TX中使用的度量单位缇（Twip）与.NET使用的度量单位像素（Pixel）的转换
        Graphics g = textControl1.CreateGraphics();
        int iTwipsPerPixel = (int)(1440 / g.DpiX);

        OpenFileDialog dlgOpen = new OpenFileDialog();

        if (dlgOpen.ShowDialog() == System.Windows.Forms.DialogResult.OK)
        {
            // 加载图片
            Image tmp = Image.FromFile(dlgOpen.FileName);

            // 获取图片父容器TextFrame
            TXTextControl.TextFrame frame = textControl1.TextParts.GetMainText().TextFrames.GetItem(1000);

            // 创建TX中的图片对象
            TXTextControl.Image image = new TXTextControl.Image(tmp);

            // 设置图片ID
            image.ID = 1001;

            //设置横向和纵向缩放比例属性，注意TextFrame中可用的空间范围应该减去Margin区域
            image.HorizontalScaling = ((frame.Size.Width - frame.InternalMargins[0] - frame.InternalMargins[2]) * 100) / (tmp.Width * iTwipsPerPixel);
            image.VerticalScaling = ((frame.Size.Height - frame.InternalMargins[1] - frame.InternalMargins[3]) * 100) / (tmp.Height * iTwipsPerPixel);

            // 将图片插入到TextFrame中
            textControl1.Images.Add(image, textControl1.InputPosition.TextPosition);
        }
    }
    }
}
